<template>
  <section class="mt-controle">
    <div class="columns is-vcentered is-mobile is-multiline ">
      <div class="column is-narrow mt-links is-half-mobile ">
        <b-field>
          <b-radio-button v-model="isList" native-value="calendrier" type="is-primary" class="mt-floating-button ">
            <nuxt-link :to="profilLink({ name: 'index', query: { mois: queryMois } })">
              <b-icon icon="calendar"></b-icon>
            </nuxt-link>
          </b-radio-button>
          <b-radio-button v-model="isList" native-value="liste" type="is-primary" class="mt-floating-button ">
            <nuxt-link :to="profilLink({ name: 'activites', query: { mois: queryMois } })">
              <b-icon icon="view-list"></b-icon>
            </nuxt-link>
          </b-radio-button>
        </b-field>
      </div>
      <div class="column mt-links is-half-mobile has-text-weight-semibold">
        <b-field class="right">
          <b-radio-button
            v-model="isAnnuel"
            native-value="annuelle"
            type="is-primary"
            class="mt-floating-button large"
            :disabled="isList !== 'calendrier'"
          >
            <nuxt-link :to="profilLink({ name: 'annuelle', query: { mois: queryMois } })">
              Année
            </nuxt-link>
          </b-radio-button>
          <b-radio-button
            v-model="isAnnuel"
            native-value="calendrier"
            type="is-primary"
            class="mt-floating-button large"
            :disabled="isList !== 'calendrier'"
          >
            <nuxt-link :to="profilLink({ name: 'index', query: { mois: queryMois } })">
              Mois
            </nuxt-link>
          </b-radio-button>
        </b-field>
      </div>
      <div v-if="isEmploye" class="column mt-links ">
        <b-switch v-model="isMyAct" class="mt-swith" :disabled="isAnnuel === 'annuelle'">
          Mes activités
        </b-switch>
      </div>
      <div class="column  is-narrow ">
        <nuxt-link
          v-if="isEmployeur || isAdmin"
          class="button mt-button  is-primary is-size-7 mt-button-fin has-text-weight-semibold"
          :to="profilLink({ name: 'activites-creer' })"
        >
          CRÉER UNE ACTIVITÉ
        </nuxt-link>
        <nuxt-link
          v-if="isEmploye"
          class="button mt-button  is-primary is-size-7 mt-button-fin has-text-weight-semibold"
          :to="profilLink({ name: 'disponibilites-creer' })"
        >
          AJOUTER MES DISPONIBILITÉS
        </nuxt-link>
      </div>
    </div>
    <div class="columns is-vcentered is-hidden-mobile">
      <b-field class="mt-type">
        <b-checkbox-button
          v-for="(typeActivite, index) in appTypesActivites"
          :key="index"
          v-model="idTypeActiviteData"
          :native-value="typeActivite.id"
          :class="resolveTypeActivite({ typeActivite }, 'mt-type-').class"
        >
          <span>{{ typeActivite.libelle }}</span
          >&nbsp;<b-icon :icon="typeActivite.codeCssIcone" />
        </b-checkbox-button>
      </b-field>
    </div>
    <div class="columns is-vcentered is-hidden-tablet">
      <b-field class="mt-type">
        <b-dropdown ref="dropdown" v-model="idTypeActiviteData" multiple aria-role="list">
          <button slot="trigger" class="button is-primary" type="button">
            <span>Types d'activités ({{ idTypeActiviteData.length }})</span>
            <b-icon icon="menu-down"></b-icon>
          </button>
          <b-dropdown-item
            v-for="(typeActivite, index) in appTypesActivites"
            :key="index"
            custom
            :value="typeActivite.id"
            aria-role="listitem"
            :class="resolveTypeActivite({ typeActivite }, 'mt-type-').class"
          >
            <b-checkbox @input="$refs.dropdown.selectItem(typeActivite.id)">
              <b-icon :icon="typeActivite.codeCssIcone" /><span> {{ typeActivite.libelle }}</span>
            </b-checkbox>
          </b-dropdown-item>
        </b-dropdown>
      </b-field>
    </div>
  </section>
</template>

<script>
import { DateTime } from 'luxon';
import userMixin from '~/components/mixins/userMixin';
import { classResolver } from '~/components/mixins/activityMixin';

export default {
  mixins: [classResolver, userMixin],
  props: {
    typeActiviteSelected: {
      type: Array,
      default: () => [],
    },
    isMyActivities: {
      type: Boolean,
      default: false,
    },
    dateCourante: {
      type: Date,
      default: () => new Date(),
    },
  },
  data() {
    return {
      isList: this.$route.name === 'profil-activites' ? 'liste' : 'calendrier',
      isAnnuel: this.$route.name === 'profil-annuelle' ? 'annuelle' : 'calendrier',
      idTypeActiviteData: Array.from(this.typeActiviteSelected),
      isMyAct: this.isMyActivities,
    };
  },
  computed: {
    queryMois() {
      return DateTime.fromJSDate(this.dateCourante).toFormat('yyyy-MM');
    },
  },
  watch: {
    idTypeActiviteData: {
      handler(newValue) {
        this.$emit('filtrer-type-activite', newValue);
      },
    },
    isMyAct: {
      handler(newValue) {
        this.$emit('filtrer-my-activities', newValue);
      },
    },
  },
  methods: {
    firstsLetters(libelle) {
      if (libelle && libelle.length > 3) {
        return libelle.substring(0, 3);
      }
      return libelle;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-controle {
  padding: 1.5rem 0;
  .mt-links /deep/ {
    .button {
      padding: 0;
    }
  }
  .right {
    float: left;
  }
  @media (max-width: 768px) {
    .right {
      float: right;
    }
  }
  .columns + .columns {
    margin-top: 0.5rem;
  }

  a {
    .icon {
      margin: calc(9px - 1px) !important;
    }
  }
  .is-primary a {
    color: $primary-invert;
  }
}
/deep/ .control.mt-floating-button {
  .button {
    box-shadow: 0 2px 8px -2px rgba(159, 159, 159, 0.5);
    border: none;

    a {
      color: $primary;
    }

    &.is-primary {
      a {
        color: $white;
      }
    }
  }

  &.large .button a {
    padding: 1em;
  }
}
</style>
